#include <stddef.h>
#include <unistd.h>

#define		TRIV_FOO	(1.11111111)
#define		TRIV_BAR	193
#define		TRIV_BAZ	"baz"

typedef struct { char *name; double value; } TrivDatum;

typedef void   		   		*VoidStar;

typedef enum { TRIV_GOOD=0, TRIV_BAD, TRIV_UGLY, TRIV_HORRIFIC } TrivErrorCode;

typedef	int*/* COMMENT EMBEDDED HERE FOR TESTING PURPOSES*/TrivIntP;

extern	long		triv_sum		(long augend, long addend);
extern	double 		triv_mult		(double op1, double op2);

extern	void		triv_mult2		(double op1,
						double op2,
						double *result);

extern	TrivDatum	*triv_datum_new		(char *name, double value);
extern  void		datum_copy		(TrivDatum *in,TrivDatum**copy);

extern	void 		triv_datum_destroy	(TrivDatum *datum);

extern	void 		triv_set_ref_i		(int *i);

extern	TrivIntP	triv_make_array_i	(void);
extern	void		triv_print_array_i	(long nelems, TrivIntP array);
/* Next prototype uses [] array syntax, to better exercise parser  */
extern	void		triv_print_array_f	(long nelems, float array [  ]);
extern	char**		triv_make_array_s	(void);
/* Peculiar spacing used in next prototype, again to better exercise parser */
extern	void		triv_print_array_s	( 	 long	nelems  ,				                			char **array);

extern	char**		triv_make_array_nts	(void);
extern	void		triv_print_array_nts	(char **array);

extern	TrivDatum**	triv_make_array_datum	(void);
extern	void		triv_print_array_datum	(long nelems,TrivDatum **array);
extern	void		triv_print_error	(TrivErrorCode err);

extern	void		triv_ignorable_func	(void);
extern	void		dummy1			(void);
extern	void		dummy2			(void);
extern	void		dummy3			(void);
extern	void		dummy4			(void);

extern	VoidStar	triv_voidstar_echo	(VoidStar input);
extern	void		triv_arg_dropper_1	(unsigned long int ul);
extern	void		triv_arg_dropper_2	(unsigned long int ul /*comment1*/,double d/*comment2*/);
extern	void		triv_toggle_error_hook	(void);
extern	ptrdiff_t	triv_subtract_ptrs	(void *p1, void *p2);
extern	size_t		triv_sizeof_int		(void);
extern	void		triv_swap_double	(double *i, double *j);
extern	void		triv_close		(int fd);
extern	int 		triv_ftell		(FILE *fp);
extern	FILE*		triv_fopen		(char *name, char *mode,
						unsigned long  *size,
						unsigned short *nlinks);

typedef int TrivInt;
extern	void		triv_int_accepter	(TrivInt i,TrivInt j,TrivInt k);

extern	int		triv_equals_array_d	(double*DA1,long nelems,double*DA2);
extern	int		triv_copy_string	(char *src,char *dest,long len);

#define			TRIV_IGNORABLE_MACRO	55
extern	int		TRIV_IGNORABLE_INT;
extern	int		TRIV_IGNORABLE_INT2;
#define			TRIV_IGNORABLE_MACRO2	110
