
slirp_include_rc("slirprc-gtk");	% Core Gtk mappinge

% Supplemental Gtk mappings % {{{
slirp_map_int("GdkCapStyle");		% These are picked up from gdkgc.h
slirp_map_int("GdkFill");		% in the Gtk module proper, but we
slirp_map_int("GdkFunction");		% don't want to process that file
slirp_map_int("GdkJoinStyle");		% for GtkExtra because it would
slirp_map_int("GdkLineStyle");		% result in superfluous duplicate
slirp_map_int("GdkSubwindowMode");	% wrappers of the funcs it contains
slirp_map_int("GdkGCValuesMask");
slirp_map_int("GtkJustification");
% }}}

% GtkExtra Mappings % {{{

slirp_set_opaque_default("GtkWidget");
slirp_map_opaque("GtkPlot*");
slirp_map_opaque("GtkPlot3D*");
slirp_map_opaque("GtkPlotCanvas*");
slirp_map_opaque("GtkPlotSurface*");
slirp_map_opaque("GtkPlotCSurface*");

slirp_set_opaque_default("GtkOpaque");
slirp_map_opaque("GtkPlotData*");
slirp_map_opaque("GtkPlotPC*");
slirp_map_opaque("GtkPlotCanvasChild*");

accepts_null_args["gtk_plot_new"] = [1];
accepts_null_args["gtk_plot_new_with_size"] = [1];
accepts_null_args["gtk_plot3d_new"] = [1];
accepts_null_args["gtk_plot3d_new_with_size"] = [1];
accepts_null_args["gtk_plot_canvas_put_line"] = [8];
accepts_null_args["gtk_plot_canvas_put_ellipse"] = [8,9];
accepts_null_args["gtk_plot_surface_set_points"] = [5,6,7];
accepts_null_args["gtk_plot_canvas_put_rectangle"] = [8,9];
accepts_null_args["gtk_plot_canvas_put_polygon"] = [8,9];
accepts_null_args["gtk_plot_axis_set_labels_attributes"] = [3,6,7];
accepts_null_args["gtk_plot_refresh"] = [2];

slirp_map_macro("GTK_PLOT_CANVAS_SET_FLAGS", "void (GtkPlot *p, gint flags)");
slirp_map_macro("GTK_PLOT_CANVAS_UNSET_FLAGS", "void (GtkPlot *p, gint flags)");
% }}}

#ignore % {{{

  % Stub these out until function signatures which return arrays of
  % primitive types [e.g. double* gtk_foo_bar(...)] are supported
  gtk_plot_data_get_x
  gtk_plot_data_get_y
  gtk_plot_data_get_z
  gtk_plot_data_get_a
  gtk_plot_data_get_dx
  gtk_plot_data_get_dy
  gtk_plot_data_get_dz
  gtk_plot_data_get_da
  gtk_plot_data_get_labels
  gtk_plot_surface_get_x
  gtk_plot_surface_get_y
  gtk_plot_surface_get_z
  gtk_plot_surface_get_dx
  gtk_plot_surface_get_dy
  gtk_plot_surface_get_dz

  % Ignore next func due to currently unsupported return type: GdkColor*
  gtk_plot_data_get_gradient_nth_color
#end % }}}

provide("slirprc-gtkx");
